/*----- PROTECTED REGION ID(PSI_PCClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        PSI_PCClass.h
//
// description : Include for the PSI_PCClass root class.
//               This class is the singleton class for.
//               the PSI_PC device class..
//               It contains all properties and methods which the .
//               PSI_PC requires only once e.g. the commands.
//
// project :     PSI power supplies.
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source:  $
// $Log:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef PSI_PCCLASS_H
#define PSI_PCCLASS_H

#include <tango.h>
#include <PSI_PC.h>

/*----- PROTECTED REGION END -----*/

namespace PSI_PC_ns
{
	/*----- PROTECTED REGION ID(PSI_PC::classes for dynamic creation) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PSI_PC::classes for dynamic creation



//=========================================
//	Define classes for attributes
//=========================================
//	Attribute CurrentSetpoint class definition
class CurrentSetpointAttrib: public Tango::Attr
{
public:
	CurrentSetpointAttrib():Attr("CurrentSetpoint",
	                   Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~CurrentSetpointAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_CurrentSetpoint(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_CurrentSetpoint(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_CurrentSetpoint_allowed(ty);}
};

//	Attribute Voltage class definition
class VoltageAttrib: public Tango::Attr
{
public:
	VoltageAttrib():Attr("Voltage",
	                   Tango::DEV_DOUBLE, Tango::READ) {};
	~VoltageAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_Voltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_Voltage_allowed(ty);}
};

//	Attribute RemoteMode class definition
class RemoteModeAttrib: public Tango::Attr
{
public:
	RemoteModeAttrib():Attr("RemoteMode",
	                   Tango::DEV_BOOLEAN, Tango::READ) {};
	~RemoteModeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_RemoteMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_RemoteMode_allowed(ty);}
};

//	Attribute Current class definition
class CurrentAttrib: public Tango::Attr
{
public:
	CurrentAttrib():Attr("Current",
	                   Tango::DEV_DOUBLE, Tango::READ) {};
	~CurrentAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_Current(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_Current_allowed(ty);}
};

//	Attribute CurrentOffset class definition
class CurrentOffsetAttrib: public Tango::Attr
{
public:
	CurrentOffsetAttrib():Attr("CurrentOffset",
	                   Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~CurrentOffsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_CurrentOffset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_CurrentOffset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_CurrentOffset_allowed(ty);}
};

//	Attribute I class definition
class IAttrib: public Tango::Attr
{
public:
	IAttrib():Attr("I",
	                   Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~IAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_I(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_I(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_I_allowed(ty);}
};

//	Attribute V class definition
class VAttrib: public Tango::Attr
{
public:
	VAttrib():Attr("V",
	                   Tango::DEV_FLOAT, Tango::READ) {};
	~VAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_V(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_V_allowed(ty);}
};

//	Attribute ErrorCode class definition
class ErrorCodeAttrib: public Tango::Attr
{
public:
	ErrorCodeAttrib():Attr("ErrorCode",
	                   Tango::DEV_LONG, Tango::READ) {};
	~ErrorCodeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_ErrorCode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_ErrorCode_allowed(ty);}
};

//	Attribute WVFAutoTrigger class definition
class WVFAutoTriggerAttrib: public Tango::Attr
{
public:
	WVFAutoTriggerAttrib():Attr("WVFAutoTrigger",
	                   Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~WVFAutoTriggerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVFAutoTrigger(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVFAutoTrigger(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVFAutoTrigger_allowed(ty);}
};

//	Attribute WVFPartitionStart class definition
class WVFPartitionStartAttrib: public Tango::Attr
{
public:
	WVFPartitionStartAttrib():Attr("WVFPartitionStart",
	                   Tango::DEV_LONG, Tango::READ) {};
	~WVFPartitionStartAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVFPartitionStart(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVFPartitionStart_allowed(ty);}
};

//	Attribute WVFRamping class definition
class WVFRampingAttrib: public Tango::Attr
{
public:
	WVFRampingAttrib():Attr("WVFRamping",
	                   Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~WVFRampingAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVFRamping(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVFRamping(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVFRamping_allowed(ty);}
};

//	Attribute WVFScaling class definition
class WVFScalingAttrib: public Tango::Attr
{
public:
	WVFScalingAttrib():Attr("WVFScaling",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE) {};
	~WVFScalingAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVFScaling(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVFScaling(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVFScaling_allowed(ty);}
};

//	Attribute WVFSelected class definition
class WVFSelectedAttrib: public Tango::Attr
{
public:
	WVFSelectedAttrib():Attr("WVFSelected",
	                   Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~WVFSelectedAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVFSelected(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVFSelected(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVFSelected_allowed(ty);}
};

//	Attribute WVFStepSize class definition
class WVFStepSizeAttrib: public Tango::Attr
{
public:
	WVFStepSizeAttrib():Attr("WVFStepSize",
	                   Tango::DEV_ULONG, Tango::READ_WRITE) {};
	~WVFStepSizeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVFStepSize(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVFStepSize(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVFStepSize_allowed(ty);}
};

//	Attribute WVFStoppedFlag class definition
class WVFStoppedFlagAttrib: public Tango::Attr
{
public:
	WVFStoppedFlagAttrib():Attr("WVFStoppedFlag",
	                   Tango::DEV_LONG, Tango::READ_WRITE) {};
	~WVFStoppedFlagAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVFStoppedFlag(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVFStoppedFlag(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVFStoppedFlag_allowed(ty);}
};

//	Attribute DAC1Setting class definition
class DAC1SettingAttrib: public Tango::Attr
{
public:
	DAC1SettingAttrib():Attr("DAC1Setting",
	                   Tango::DEV_LONG, Tango::READ_WRITE) {};
	~DAC1SettingAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_DAC1Setting(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_DAC1Setting(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_DAC1Setting_allowed(ty);}
};

//	Attribute DAC1Offset class definition
class DAC1OffsetAttrib: public Tango::Attr
{
public:
	DAC1OffsetAttrib():Attr("DAC1Offset",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE) {};
	~DAC1OffsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_DAC1Offset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_DAC1Offset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_DAC1Offset_allowed(ty);}
};

//	Attribute DAC1Scaling class definition
class DAC1ScalingAttrib: public Tango::Attr
{
public:
	DAC1ScalingAttrib():Attr("DAC1Scaling",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE) {};
	~DAC1ScalingAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_DAC1Scaling(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_DAC1Scaling(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_DAC1Scaling_allowed(ty);}
};

//	Attribute DAC2Setting class definition
class DAC2SettingAttrib: public Tango::Attr
{
public:
	DAC2SettingAttrib():Attr("DAC2Setting",
	                   Tango::DEV_LONG, Tango::READ_WRITE) {};
	~DAC2SettingAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_DAC2Setting(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_DAC2Setting(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_DAC2Setting_allowed(ty);}
};

//	Attribute DAC2Offset class definition
class DAC2OffsetAttrib: public Tango::Attr
{
public:
	DAC2OffsetAttrib():Attr("DAC2Offset",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE) {};
	~DAC2OffsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_DAC2Offset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_DAC2Offset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_DAC2Offset_allowed(ty);}
};

//	Attribute DAC2Scaling class definition
class DAC2ScalingAttrib: public Tango::Attr
{
public:
	DAC2ScalingAttrib():Attr("DAC2Scaling",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE) {};
	~DAC2ScalingAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_DAC2Scaling(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_DAC2Scaling(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_DAC2Scaling_allowed(ty);}
};

//	Attribute SoftwareWaveform class definition
class SoftwareWaveformAttrib: public Tango::SpectrumAttr
{
public:
	SoftwareWaveformAttrib():SpectrumAttr("SoftwareWaveform",
	                   Tango::DEV_DOUBLE, Tango::READ_WRITE, 1000000) {};
	~SoftwareWaveformAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_SoftwareWaveform(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_SoftwareWaveform(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_SoftwareWaveform_allowed(ty);}
};

//	Attribute ErrorCodes class definition
class ErrorCodesAttrib: public Tango::SpectrumAttr
{
public:
	ErrorCodesAttrib():SpectrumAttr("ErrorCodes",
	                   Tango::DEV_SHORT, Tango::READ, 5) {};
	~ErrorCodesAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_ErrorCodes(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_ErrorCodes_allowed(ty);}
};

//	Attribute ErrorLabel class definition
class ErrorLabelAttrib: public Tango::SpectrumAttr
{
public:
	ErrorLabelAttrib():SpectrumAttr("ErrorLabel",
	                   Tango::DEV_STRING, Tango::READ, 5) {};
	~ErrorLabelAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_ErrorLabel(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_ErrorLabel_allowed(ty);}
};

//	Attribute Errors class definition
class ErrorsAttrib: public Tango::SpectrumAttr
{
public:
	ErrorsAttrib():SpectrumAttr("Errors",
	                   Tango::DEV_STRING, Tango::READ, 20) {};
	~ErrorsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_Errors(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_Errors_allowed(ty);}
};

//	Attribute WVF0 class definition
class WVF0Attrib: public Tango::SpectrumAttr
{
public:
	WVF0Attrib():SpectrumAttr("WVF0",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE, 16383) {};
	~WVF0Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVF0(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVF0(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVF0_allowed(ty);}
};

//	Attribute WVF1 class definition
class WVF1Attrib: public Tango::SpectrumAttr
{
public:
	WVF1Attrib():SpectrumAttr("WVF1",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE, 16383) {};
	~WVF1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVF1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVF1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVF1_allowed(ty);}
};

//	Attribute WVF2 class definition
class WVF2Attrib: public Tango::SpectrumAttr
{
public:
	WVF2Attrib():SpectrumAttr("WVF2",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE, 16383) {};
	~WVF2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVF2(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVF2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVF2_allowed(ty);}
};

//	Attribute WVF3 class definition
class WVF3Attrib: public Tango::SpectrumAttr
{
public:
	WVF3Attrib():SpectrumAttr("WVF3",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE, 16383) {};
	~WVF3Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVF3(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVF3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVF3_allowed(ty);}
};

//	Attribute WVF4 class definition
class WVF4Attrib: public Tango::SpectrumAttr
{
public:
	WVF4Attrib():SpectrumAttr("WVF4",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE, 16383) {};
	~WVF4Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVF4(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVF4(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVF4_allowed(ty);}
};

//	Attribute WVF5 class definition
class WVF5Attrib: public Tango::SpectrumAttr
{
public:
	WVF5Attrib():SpectrumAttr("WVF5",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE, 16383) {};
	~WVF5Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVF5(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVF5(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVF5_allowed(ty);}
};

//	Attribute WVF6 class definition
class WVF6Attrib: public Tango::SpectrumAttr
{
public:
	WVF6Attrib():SpectrumAttr("WVF6",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE, 16383) {};
	~WVF6Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVF6(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVF6(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVF6_allowed(ty);}
};

//	Attribute WVF7 class definition
class WVF7Attrib: public Tango::SpectrumAttr
{
public:
	WVF7Attrib():SpectrumAttr("WVF7",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE, 16383) {};
	~WVF7Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVF7(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVF7(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVF7_allowed(ty);}
};

//	Attribute WVF8 class definition
class WVF8Attrib: public Tango::SpectrumAttr
{
public:
	WVF8Attrib():SpectrumAttr("WVF8",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE, 16383) {};
	~WVF8Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVF8(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVF8(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVF8_allowed(ty);}
};

//	Attribute WVF9 class definition
class WVF9Attrib: public Tango::SpectrumAttr
{
public:
	WVF9Attrib():SpectrumAttr("WVF9",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE, 16383) {};
	~WVF9Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVF9(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVF9(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVF9_allowed(ty);}
};

//	Attribute WVF10 class definition
class WVF10Attrib: public Tango::SpectrumAttr
{
public:
	WVF10Attrib():SpectrumAttr("WVF10",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE, 16383) {};
	~WVF10Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVF10(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVF10(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVF10_allowed(ty);}
};

//	Attribute WVF11 class definition
class WVF11Attrib: public Tango::SpectrumAttr
{
public:
	WVF11Attrib():SpectrumAttr("WVF11",
	                   Tango::DEV_FLOAT, Tango::READ_WRITE, 16383) {};
	~WVF11Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<PSI_PC *>(dev))->read_WVF11(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<PSI_PC *>(dev))->write_WVF11(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<PSI_PC *>(dev))->is_WVF11_allowed(ty);}
};





//=========================================
//	Define classes for commands
//=========================================
//	Command On class definition
class OnClass : public Tango::Command
{
public:
	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_On_allowed(any);}
};

//	Command Off class definition
class OffClass : public Tango::Command
{
public:
	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OffClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_Off_allowed(any);}
};

//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_Reset_allowed(any);}
};

//	Command ResetInterlocks class definition
class ResetInterlocksClass : public Tango::Command
{
public:
	ResetInterlocksClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetInterlocksClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetInterlocksClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_ResetInterlocks_allowed(any);}
};

//	Command DisableInterlocks class definition
class DisableInterlocksClass : public Tango::Command
{
public:
	DisableInterlocksClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	DisableInterlocksClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~DisableInterlocksClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_DisableInterlocks_allowed(any);}
};

//	Command EnableInterlocks class definition
class EnableInterlocksClass : public Tango::Command
{
public:
	EnableInterlocksClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	EnableInterlocksClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~EnableInterlocksClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_EnableInterlocks_allowed(any);}
};

//	Command InterlockStatus class definition
class InterlockStatusClass : public Tango::Command
{
public:
	InterlockStatusClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	InterlockStatusClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~InterlockStatusClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_InterlockStatus_allowed(any);}
};

//	Command Read_PSC_register class definition
class Read_PSC_registerClass : public Tango::Command
{
public:
	Read_PSC_registerClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Read_PSC_registerClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Read_PSC_registerClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_Read_PSC_register_allowed(any);}
};

//	Command StopSoftwareWaveform class definition
class StopSoftwareWaveformClass : public Tango::Command
{
public:
	StopSoftwareWaveformClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopSoftwareWaveformClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopSoftwareWaveformClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_StopSoftwareWaveform_allowed(any);}
};

//	Command StartSoftwareWaveform class definition
class StartSoftwareWaveformClass : public Tango::Command
{
public:
	StartSoftwareWaveformClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartSoftwareWaveformClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartSoftwareWaveformClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_StartSoftwareWaveform_allowed(any);}
};

//	Command Connect class definition
class ConnectClass : public Tango::Command
{
public:
	ConnectClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ConnectClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ConnectClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_Connect_allowed(any);}
};

//	Command Update class definition
class UpdateClass : public Tango::Command
{
public:
	UpdateClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	UpdateClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~UpdateClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_Update_allowed(any);}
};

//	Command WVFStart class definition
class WVFStartClass : public Tango::Command
{
public:
	WVFStartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	WVFStartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~WVFStartClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_WVFStart_allowed(any);}
};

//	Command WVFStop class definition
class WVFStopClass : public Tango::Command
{
public:
	WVFStopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	WVFStopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~WVFStopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_WVFStop_allowed(any);}
};

//	Command WVFTrigger class definition
class WVFTriggerClass : public Tango::Command
{
public:
	WVFTriggerClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	WVFTriggerClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~WVFTriggerClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<PSI_PC *>(dev))->is_WVFTrigger_allowed(any);}
};





/**
 *	The TemplateDevServClass singleton definition
 */

class
#ifdef _TG_WINDOWS_
	__declspec(dllexport)
#endif
	PSI_PCClass : public Tango::DeviceClass
{
	/*----- PROTECTED REGION ID(PSI_PC::Additionnal DServer data members) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	PSI_PC::Additionnal DServer data members




//	Class properties data members
public:
	//	Interlock1:	
	string	interlock1;
	//	Interlock2:	message to be shown for external interlock 2
	string	interlock2;
	//	Interlock3:	message to be shown for External Interlock 3
	string	interlock3;
	//	Interlock4:	message to be shown for external interlock 4
	string	interlock4;
public:
//	write class properties data members
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static PSI_PCClass *init(const char *);
	static PSI_PCClass *instance();
	~PSI_PCClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	PSI_PCClass(string &);
	static PSI_PCClass *_instance;
	void command_factory();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	void get_class_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
	void create_static_attribute_list(vector<Tango::Attr *> &);
	void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
	vector<string>	defaultAttList;


};

}	//	namespace

#endif	//	PSI_PCCLASS_H

